-- Do not edit! Automatically created with doctest-extract from src/Data/Array/Comfort/Shape.hs
{-# LINE 125 "src/Data/Array/Comfort/Shape.hs" #-}

module DocTest.Data.Array.Comfort.Shape where

import Test.DocTest.Base
import qualified Test.DocTest.Driver as DocTest

{-# LINE 126 "src/Data/Array/Comfort/Shape.hs" #-}
import     qualified Data.Array.Comfort.Shape as Shape
import     qualified Data.Map as Map
import     qualified Data.Set as Set
import     Data.Array.Comfort.Shape ((::+)((::+)))

import     Test.ChasingBottoms.IsBottom (isBottom)
import     Control.DeepSeq (rnf)

test :: DocTest.T ()
test = do
 DocTest.printPrefix "Data.Array.Comfort.Shape:332: "
{-# LINE 332 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 332 "src/Data/Array/Comfort/Shape.hs" #-}
   (Shape.indices ())
  [ExpectedLine [LineChunk "[()]"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:355: "
{-# LINE 355 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 355 "src/Data/Array/Comfort/Shape.hs" #-}
   (Shape.indices (Shape.ZeroBased (7::Int)))
  [ExpectedLine [LineChunk "[0,1,2,3,4,5,6]"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:413: "
{-# LINE 413 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 413 "src/Data/Array/Comfort/Shape.hs" #-}
   (Shape.indices (Shape.OneBased (7::Int)))
  [ExpectedLine [LineChunk "[1,2,3,4,5,6,7]"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:463: "
{-# LINE 463 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 463 "src/Data/Array/Comfort/Shape.hs" #-}
   (Shape.indices (Shape.Range (-5) (5::Int)))
  [ExpectedLine [LineChunk "[-5,-4,-3,-2,-1,0,1,2,3,4,5]"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:465: "
{-# LINE 465 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 465 "src/Data/Array/Comfort/Shape.hs" #-}
   (Shape.indices (Shape.Range (-1,-1) (1::Int,1::Int)))
  [ExpectedLine [LineChunk "[(-1,-1),(-1,0),(-1,1),(0,-1),(0,0),(0,1),(1,-1),(1,0),(1,1)]"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:515: "
{-# LINE 515 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 515 "src/Data/Array/Comfort/Shape.hs" #-}
   (Shape.indices (Shape.Shifted (-4) (8::Int)))
  [ExpectedLine [LineChunk "[-4,-3,-2,-1,0,1,2,3]"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:580: "
{-# LINE 580 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 580 "src/Data/Array/Comfort/Shape.hs" #-}
   (Shape.indices (Shape.Enumeration :: Shape.Enumeration Ordering))
  [ExpectedLine [LineChunk "[LT,EQ,GT]"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:644: "
{-# LINE 644 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 644 "src/Data/Array/Comfort/Shape.hs" #-}
   (Shape.indices (Set.fromList "comfort"))
  [ExpectedLine [LineChunk "\"cfmort\""]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:680: "
{-# LINE 680 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 680 "src/Data/Array/Comfort/Shape.hs" #-}
   (Shape.indices $ fmap Shape.ZeroBased $ Map.fromList [('b', (0::Int)), ('a', 5), ('c', 2)])
  [ExpectedLine [LineChunk "[('a',0),('a',1),('a',2),('a',3),('a',4),('c',0),('c',1)]"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:745: "
{-# LINE 745 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 745 "src/Data/Array/Comfort/Shape.hs" #-}
   (
  let sh2 = (Shape.ZeroBased (2::Int), Shape.ZeroBased (2::Int)) in
  let sh3 = (Shape.ZeroBased (3::Int), Shape.ZeroBased (3::Int)) in
  (Shape.offset sh3 $ Shape.indexFromOffset sh2 3,
  Shape.offset (Shape.Deferred sh3) $
  Shape.indexFromOffset (Shape.Deferred sh2) 3)
  )
  [ExpectedLine [LineChunk "(4,3)"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:849: "
{-# LINE 849 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 849 "src/Data/Array/Comfort/Shape.hs" #-}
   (Shape.indices (Shape.ZeroBased (3::Int), Shape.ZeroBased (3::Int)))
  [ExpectedLine [LineChunk "[(0,0),(0,1),(0,2),(1,0),(1,1),(1,2),(2,0),(2,1),(2,2)]"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:971: "
{-# LINE 971 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 971 "src/Data/Array/Comfort/Shape.hs" #-}
   (Shape.indices $ Shape.Square $ Shape.ZeroBased (3::Int))
  [ExpectedLine [LineChunk "[(0,0),(0,1),(0,2),(1,0),(1,1),(1,2),(2,0),(2,1),(2,2)]"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:1025: "
{-# LINE 1025 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 1025 "src/Data/Array/Comfort/Shape.hs" #-}
   (Shape.indices $ Shape.Cube $ Shape.ZeroBased (2::Int))
  [ExpectedLine [LineChunk "[(0,0,0),(0,0,1),(0,1,0),(0,1,1),(1,0,0),(1,0,1),(1,1,0),(1,1,1)]"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:1084: "
{-# LINE 1084 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 1084 "src/Data/Array/Comfort/Shape.hs" #-}
   (Shape.indices $ Shape.Triangular Shape.Upper $ Shape.ZeroBased (3::Int))
  [ExpectedLine [LineChunk "[(0,0),(0,1),(0,2),(1,1),(1,2),(2,2)]"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:1086: "
{-# LINE 1086 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 1086 "src/Data/Array/Comfort/Shape.hs" #-}
   (Shape.indices $ Shape.Triangular Shape.Lower $ Shape.ZeroBased (3::Int))
  [ExpectedLine [LineChunk "[(0,0),(1,0),(1,1),(2,0),(2,1),(2,2)]"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:1218: "
{-# LINE 1218 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 1218 "src/Data/Array/Comfort/Shape.hs" #-}
   (Shape.indices $ Shape.simplexAscending (replicate 3 Shape.AllDistinct) $ Shape.ZeroBased (4::Int))
  [ExpectedLine [LineChunk "[[0,1,2],[0,1,3],[0,2,3],[1,2,3]]"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:1220: "
{-# LINE 1220 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 1220 "src/Data/Array/Comfort/Shape.hs" #-}
   (Shape.indices $ Shape.simplexAscending (replicate 3 Shape.SomeRepetitive) $ Shape.ZeroBased (3::Int))
  [ExpectedLine [LineChunk "[[0,0,0],[0,0,1],[0,0,2],[0,1,1],[0,1,2],[0,2,2],[1,1,1],[1,1,2],[1,2,2],[2,2,2]]"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:1222: "
{-# LINE 1222 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 1222 "src/Data/Array/Comfort/Shape.hs" #-}
   (Shape.indices $ Shape.simplexAscending [Shape.Repetitive,Shape.Distinct,Shape.Repetitive] $ Shape.ZeroBased (4::Int))
  [ExpectedLine [LineChunk "[[0,0,1],[0,0,2],[0,0,3],[0,1,2],[0,1,3],[0,2,3],[1,1,2],[1,1,3],[1,2,3],[2,2,3]]"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:1224: "
{-# LINE 1224 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 1224 "src/Data/Array/Comfort/Shape.hs" #-}
   (Shape.indices $ Shape.simplexAscending [Shape.Repetitive,Shape.Distinct,Shape.Distinct] $ Shape.ZeroBased (4::Int))
  [ExpectedLine [LineChunk "[[0,0,1],[0,0,2],[0,0,3],[0,1,2],[0,1,3],[0,2,3],[1,1,2],[1,1,3],[1,2,3],[2,2,3]]"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:1227: "
{-# LINE 1227 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 1227 "src/Data/Array/Comfort/Shape.hs" #-}
   (Shape.indices $ Shape.simplexDescending (replicate 3 Shape.AllDistinct) $ Shape.ZeroBased (4::Int))
  [ExpectedLine [LineChunk "[[2,1,0],[3,1,0],[3,2,0],[3,2,1]]"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:1229: "
{-# LINE 1229 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 1229 "src/Data/Array/Comfort/Shape.hs" #-}
   (Shape.indices $ Shape.simplexDescending (replicate 3 Shape.SomeRepetitive) $ Shape.ZeroBased (3::Int))
  [ExpectedLine [LineChunk "[[0,0,0],[1,0,0],[1,1,0],[1,1,1],[2,0,0],[2,1,0],[2,1,1],[2,2,0],[2,2,1],[2,2,2]]"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:1231: "
{-# LINE 1231 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 1231 "src/Data/Array/Comfort/Shape.hs" #-}
   (Shape.indices $ Shape.simplexDescending [Shape.Repetitive,Shape.Distinct,Shape.Repetitive] $ Shape.ZeroBased (4::Int))
  [ExpectedLine [LineChunk "[[1,1,0],[2,1,0],[2,2,0],[2,2,1],[3,1,0],[3,2,0],[3,2,1],[3,3,0],[3,3,1],[3,3,2]]"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:1233: "
{-# LINE 1233 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 1233 "src/Data/Array/Comfort/Shape.hs" #-}
   (Shape.indices $ Shape.simplexDescending [Shape.Repetitive,Shape.Distinct,Shape.Distinct] $ Shape.ZeroBased (4::Int))
  [ExpectedLine [LineChunk "[[1,1,0],[2,1,0],[2,2,0],[2,2,1],[3,1,0],[3,2,0],[3,2,1],[3,3,0],[3,3,1],[3,3,2]]"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:1467: "
{-# LINE 1467 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.property
{-# LINE 1467 "src/Data/Array/Comfort/Shape.hs" #-}
     (let shape = Shape.Cyclic (10::Int) in Shape.offset shape (-1) == Shape.offset shape 9)
 DocTest.printPrefix "Data.Array.Comfort.Shape:1472: "
{-# LINE 1472 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 1472 "src/Data/Array/Comfort/Shape.hs" #-}
   (Shape.indices (Shape.Cyclic (7::Int)))
  [ExpectedLine [LineChunk "[0,1,2,3,4,5,6]"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:1516: "
{-# LINE 1516 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 1516 "src/Data/Array/Comfort/Shape.hs" #-}
   (Shape.indices (Shape.ZeroBased (3::Int) ::+ Shape.Range 'a' 'c'))
  [ExpectedLine [LineChunk "[Left 0,Left 1,Left 2,Right 'a',Right 'b',Right 'c']"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:1603: "
{-# LINE 1603 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 1603 "src/Data/Array/Comfort/Shape.hs" #-}
   (rnf (Shape.NestedTuple (Shape.Element 1, Shape.Element 2)))
  [ExpectedLine [LineChunk "()"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:1605: "
{-# LINE 1605 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 1605 "src/Data/Array/Comfort/Shape.hs" #-}
   (rnf (Shape.NestedTuple (Shape.Element 1, (Shape.Element 2, Shape.Element 3))))
  [ExpectedLine [LineChunk "()"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:1607: "
{-# LINE 1607 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 1607 "src/Data/Array/Comfort/Shape.hs" #-}
   (isBottom $ rnf (Shape.NestedTuple (Shape.Element undefined, Shape.Element 2)))
  [ExpectedLine [LineChunk "True"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:1609: "
{-# LINE 1609 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 1609 "src/Data/Array/Comfort/Shape.hs" #-}
   (isBottom $ rnf (Shape.NestedTuple (Shape.Element undefined, (Shape.Element 2, Shape.Element 3))))
  [ExpectedLine [LineChunk "True"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:1611: "
{-# LINE 1611 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 1611 "src/Data/Array/Comfort/Shape.hs" #-}
   (isBottom $ rnf (Shape.NestedTuple (Shape.Element 1, (Shape.Element undefined, Shape.Element 3))))
  [ExpectedLine [LineChunk "True"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:1613: "
{-# LINE 1613 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 1613 "src/Data/Array/Comfort/Shape.hs" #-}
   (isBottom $ rnf (Shape.NestedTuple (Shape.Element 1, (Shape.Element 2, Shape.Element undefined))))
  [ExpectedLine [LineChunk "True"]]
